package jTrolog.engine;

import jTrolog.terms.Struct;

import java.util.List;

/**
 * @author janerist@stud.ntnu.no
 * @author ivar.orstavik@hist.no
 */
class ChoicePoint {

    Struct struct;
    private int termCtx;
    public boolean hasRightSideAlternatives = false;
    public ChoicePoint parentComma = null;
    private int execCtx;

    //alternatives
    private List alternatives;
    private int altPos;
    private int alternativeCount;

    ChoicePoint(Struct term, int ctx) {
        this.termCtx = ctx;
        struct = term;
    }

    public String toString() {
        return struct + "          \n" +
                "termCtx: " + termCtx + "\n" +
                "alternatives: " + (alternatives != null ? "yes" : "no") + "\n" +
                "rightSideUnsolved: " + (hasRightSideAlternatives ? "yep" : "nope") + "\n";
    }

    public int getTermCtx() {
        return termCtx;
    }

    public void setExecCtx(int execCtx) {
        this.execCtx = execCtx;
    }

    public int getExecCtx() {
        return execCtx;
    }

    public void setAlternatives(List alternatives) {
        this.alternatives = alternatives;
        this.altPos = 0;
        this.alternativeCount = alternatives.size();
    }

    boolean hasAlternatives() {
        return alternatives != null;
    }

    Object nextAlternative() {
        Object alt = alternatives.get(altPos++);
        if (altPos >= alternativeCount)
            alternatives = null;
        return alt;
    }

    public void cutAlternatives() {
        altPos = alternativeCount;
        alternatives = null;
    }

    /**
     * recycles previously used CP objects on the stack
     * @param stack
     * @param i
     * @param struct
     * @param ctx
     */
    static void create(ChoicePoint[] stack, int i, Struct struct, int ctx) {
        if (stack[i] == null) {
            stack[i] = new ChoicePoint(struct, ctx);
            return;
        }
        stack[i].struct = struct;
        stack[i].termCtx = ctx;
        stack[i].execCtx = 0;
        stack[i].alternatives = null;
        stack[i].altPos = 0;
        stack[i].alternativeCount = 0;
        stack[i].hasRightSideAlternatives = false;
        stack[i].parentComma = null;
    }
}
