/*
 * tuProlog - Copyright (C) 2001-2002  aliCE team at deis.unibo.it
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package jTrolog.engine;

import jTrolog.parser.Parser;
import jTrolog.lib.Library;

import java.lang.reflect.Method;

/**
 * Wrapper listing a reflectable library method, a library object for a predicateIndicator
 */
class PrimitiveInfo {

    private Method method;
	private Library source;
	private String predicateIndicator;

	PrimitiveInfo(Library lib, Method m, String functor, int arity) {
        if (!Parser.isAtom(functor))
            functor = "'" + functor + "'";
        predicateIndicator = functor + "/" + arity;
		source = lib;
		method = m;
	}

	String getKey() {
		return predicateIndicator;
	}

    Library getSource() {
        return source;
    }

    Method getMethod() {
        return method;
    }

    public String toString() {
        return "[ primitive: method "+method.getName()+" - "+source.getClass().getName()+" ]\n";
    }
}