package jTrolog.terms;

import jTrolog.errors.InvalidTermException;
import jTrolog.terms.Struct;

public class StructAtom extends Struct {

    public StructAtom(String name) {
        super(name, new Term[0]);
        if (name.equals("[]") )
            throw new InvalidTermException("EmptyList Structs must be created using: \n" +
                    "Struct.createEmptyList() or \n" +
                    "Struct.create(\"[]\") or \n" +
                    "new StructList()\n" +
                    "Replace the new Struct(String s) with one of the two methods above and you should be fine!");

    }

    public boolean equals(Object t) {
        return t instanceof StructAtom && getName() == ((StructAtom) t).getName();
    }

    public String toString() {
        return getName();
    }

    public String toStringSmall() {
        String name = getName();
        if (name.length() < 25)
            return name;
        return name.substring(0,23) + "..";
    }
}