package jTrolog.terms;

import jTrolog.terms.StructList;
import jTrolog.terms.Term;
import jTrolog.terms.Wrapper;
import jTrolog.engine.BindingsTable;

import java.util.Iterator;

/**
 * @author ivar.orstavik@hist.no
 */
public class WrapStructList extends StructList implements Wrapper {

    public int context;
    private StructList basis;

    public WrapStructList(StructList original, int renameVarID) {
        basis = original;
        context = renameVarID;
    }

    public Term getArg(int i) {
        return BindingsTable.wrapWithID(basis.getArg(i), context);
    }

    public String getPredicateIndicator() {
        return basis.getPredicateIndicator();
    }

    public boolean hasPredicateIndicator(String name, int arity) {
        return basis.hasPredicateIndicator(name, arity);
    }

    public int getArity() {
        return basis.getArity();
    }

    public String getName() {
        return basis.getName();
    }

    String getOpType() {
        return basis.getOpType();
    }

    int getOpPrio() {
        return basis.getOpPrio();
    }

    public int getContext() {
        return context;
    }

    public Term getBasis() {
        return basis;
    }

    public Iterator children() {
        return new WrappedIterator(basis.children(), context);
    }
}
