package jTrolog.engine;

import fit.Fixture;
import jTrolog.parser.Parser;
import jTrolog.terms.Term;

public class EvaluationFixture extends Fixture {

    public String evaluable;
    private String exception;

    /* Registers */

    public void evaluable(String evaluable) {
        this.evaluable = evaluable;
    }

    /* Meters */

    public Term value() {
        try {
            Prolog engine = new Prolog();
            Solution result = engine.solve("eval(" + evaluable.substring(0, evaluable.length()-1) + ").");
            return result.getSolution();
        } catch (Throwable e) {
            exception = e.getMessage();
            return null;
        }
    }

    public String exception() {
        value();
        String temp = exception;
        exception = null;
        if (temp == null)
            return "no exception";
        return temp;
    }

    /* Utilities */

    public Object parse(String s, Class type) throws Exception {
        if (type.equals(jTrolog.terms.Term.class))
            return BindingsTable.wrapWithID(new Parser(s).nextTerm(false), 0);
        return super.parse(s, type);
    }

}