package jTrolog.engine;

import junit.framework.TestCase;
import jTrolog.errors.NoMorePrologSolutions;

public class DCGTestCase extends TestCase {

    public void testDCG() throws Throwable, NoMorePrologSolutions {
        Prolog engine = new Prolog("jTrolog.lib.DCGLibrary");
        String theory = "s    -->  np, vp.          /* query with ?- s([word1,word2,...], []). */\n" +
                "np   -->  det, n.\n" +
                "np   -->  det, adjp, n.\n" +
                "adjp -->  adj.\n" +
                "vp   -->  v.\n" +
                "vp   -->  v, np.\n" +
                "\n" +
                "n   --> [N],   { noun(N) }.\n" +
                "v   --> [V],   { verb(V) }.\n" +
                "adj --> [Adj], { adj(Adj) }.\n" +
                "det --> [Det], { det(Det) }.\n" +
                "\n" +
                "noun(boy).\n" +
                "noun(girl).\n" +
                "verb(loves).\n" +
                "adj(sane).\n" +
                "adj(pretty).\n" +
                "adj(handsome).\n" +
                "det(the).\n" +
                "det(a).\n" +
                "det(every). ";

        engine.addTheory(theory);
//        engine.solve("dcg_preprocess.");

        Solution result = engine.solve("phrase(s,A).");
        int sixhundred = 0;
        while (engine.hasOpenAlternatives()){
            System.out.println(result);
            result = engine.solveNext();
            sixhundred++;
        }
        assertTrue(sixhundred ==600);
    }
}
