package jTrolog.engine;

import junit.framework.TestCase;
import jTrolog.errors.InvalidTermException;
import jTrolog.terms.Int;
import jTrolog.terms.Struct;
import jTrolog.terms.Var;

public class DoubleTestCase extends TestCase {

    public void testEqualsToStruct() {
        jTrolog.terms.Double zero = new jTrolog.terms.Double(0);
        Struct s = Struct.emptyList;
        assertFalse(zero.equals(s));
    }

    public void testEqualsToVar() throws InvalidTermException {
        jTrolog.terms.Double one = new jTrolog.terms.Double(1);
        Var x = new Var("X", 0);
        assertFalse(one.equals(x));
    }

    public void testEqualsToDouble() {
        jTrolog.terms.Double zero = new jTrolog.terms.Double(0);
        jTrolog.terms.Double one = new jTrolog.terms.Double(1);
        assertFalse(zero.equals(one));
        jTrolog.terms.Double anotherZero = new jTrolog.terms.Double(0.0);
        assertTrue(anotherZero.equals(zero));
    }

    public void testEqualsToFloat() {
        // TODO Test Double numbers for equality with Float numbers
    }

    public void testEqualsToInt() throws Throwable {
        jTrolog.terms.Double doubleOne = new jTrolog.terms.Double(1.0);
        Int integerOne = new Int(1);
        assertFalse(doubleOne.equals(integerOne));

        //tests unification with Int
        String th = "'='(1, 1.0).";
        Prolog p = new Prolog();
        Solution res = p.solve(th);
        assertFalse(res.success());
    }

    public void testEqualsToLong() {
        // TODO Test Double numbers for equality with Long numbers
    }

}
