package jTrolog.engine;

import junit.framework.TestCase;
import jTrolog.errors.InvalidTermException;
import jTrolog.terms.Int;
import jTrolog.terms.Struct;
import jTrolog.terms.Var;

public class IntTestCase extends TestCase {

    public void testEqualsToStruct() {
        Struct s = Struct.emptyList;
        Int zero = new Int(0);
        assertFalse(zero.equals(s));
    }

    public void testEqualsToVar() throws InvalidTermException {
        Var x = new Var("X", 0);
        Int one = new Int(1);
        assertFalse(one.equals(x));
    }

    public void testEqualsToInt() {
        Int zero = new Int(0);
        Int one = new Int(1);
        assertFalse(zero.equals(one));
        Int anotherZero = new Int(1-1);
        assertTrue(anotherZero.equals(zero));
    }

    public void testEqualsToLong() {
        // TODO Test Int numbers for equality with Long numbers
    }

    public void testEqualsToDouble() {
        Int integerOne = new Int(1);
        jTrolog.terms.Double doubleOne = new jTrolog.terms.Double(1);
        assertFalse(integerOne.equals(doubleOne));
    }

    public void testEqualsToFloat() {
        // TODO Test Int numbers for equality with Float numbers
    }

}
