package jTrolog.engine;

import junit.framework.TestCase;

import java.io.PrintStream;
import java.io.OutputStream;
import java.io.IOException;

import jTrolog.lib.TestLibrary;
import jTrolog.terms.Int;

public class LibraryTestCase extends TestCase {

    public void testLibraryFunctor() throws Throwable {
        Prolog engine = new Prolog();
        engine.loadLibrary(new TestLibrary());
        Solution goal = engine.solve("N is sum(1, 3).");
        assertTrue(goal.success());
        assertEquals(new Int(4), goal.getBinding("N"));
    }

    private static class TestOutputStream extends OutputStream {
        String res = "";
        public void write(int b) throws IOException {
            res += (char) b;
        }
    }

    public void testLibraryPredicate() throws Throwable {
        Prolog engine = new Prolog();
        engine.loadLibrary(new TestLibrary());
        PrintStream orig = System.out;
        TestOutputStream temp = new TestOutputStream();
        System.setOut(new PrintStream(temp));
        engine.solve("println(sum(5)).");
        assertEquals("sum(5)\r\n",temp.res);
        System.setOut(orig);
    }

}
