package jTrolog.engine;

import junit.framework.TestCase;

import java.util.Iterator;

/**
 * @author ivar.orstavik@hist.no
 */
public class OperatorTestCase extends TestCase {

    public void testEngineInitialization() {

        String expected =
                "op(1200, fx, :-)\n" +
                "op(1200, xfx, :-)\n" +
                "op(1200, fx, ?-)\n" +
                "op(1100, xfy, ;)\n" +
                "op(1050, xfy, ->)\n" +
                "op(1000, xfy, ,)\n" +
                "op(900, fy, \\+)\n" +
                "op(900, fy, not)\n" +
                "op(700, xfx, =)\n" +
                "op(700, xfx, \\=)\n" +
                "op(700, xfx, ==)\n" +
                "op(700, xfx, \\==)\n" +
                "op(700, xfx, @>)\n" +
                "op(700, xfx, @<)\n" +
                "op(700, xfx, @=<)\n" +
                "op(700, xfx, @>=)\n" +
                "op(700, xfx, =:=)\n" +
                "op(700, xfx, =\\=)\n" +
                "op(700, xfx, >)\n" +
                "op(700, xfx, <)\n" +
                "op(700, xfx, =<)\n" +
                "op(700, xfx, >=)\n" +
                "op(700, xfx, is)\n" +
                "op(700, xfx, =..)\n" +
                "op(500, yfx, +)\n" +
                "op(500, yfx, -)\n" +
                "op(500, yfx, /\\)\n" +
                "op(500, yfx, \\/)\n" +
                "op(400, yfx, *)\n" +
                "op(400, yfx, /)\n" +
                "op(400, yfx, //)\n" +
                "op(400, yfx, >>)\n" +
                "op(400, yfx, <<)\n" +
                "op(400, yfx, rem)\n" +
                "op(400, yfx, mod)\n" +
                "op(200, xfx, **)\n" +
                "op(200, xfy, ^)\n" +
                "op(200, fy, \\)\n" +
                "op(200, fy, -)\n" +
                "op(300, yfx, div)\n" +
                "op(200, fx, sin)\n" +
                "op(200, fx, cos)\n" +
                "op(200, fx, sqrt)\n" +
                "op(200, fx, atan)\n" +
                "op(200, fx, exp)\n" +
                "op(200, fx, log)\n";

        Prolog engine = new Prolog();
        String value = "";
        int count = 0;
        for (Iterator it = engine.getCurrentOperators(); it.hasNext(); count++)
            value += it.next() + "\n";

        assertEquals(value,expected);
        assertEquals(46,count);
    }


}
