package jTrolog.engine;

import junit.framework.TestCase;
import jTrolog.errors.PrologException;

public class StateRuleSelectionTestCase extends TestCase {

    public void testUnknownPredicateInQuery() throws Throwable {
        Prolog engine = new Prolog();
        try {
            engine.solve("p(X).");
            fail();
        } catch (Throwable throwable) {
            assertTrue(throwable.getMessage().indexOf("p/1") > 0);
            assertTrue(throwable.getMessage().indexOf("is unknown") > 0);
        }
    }

    public void testUnknownPredicateInTheory() throws PrologException {
        Prolog engine = new Prolog();
        String theory = "p(X) :- a, b. \nb.";
        engine.setTheory(theory);
        try {
            engine.solve("p(X).");
            fail();
        } catch (Throwable throwable) {
            assertTrue(throwable.getMessage().indexOf("a/0") > 0);
            assertTrue(throwable.getMessage().indexOf("is unknown") > 0);
        }
    }

}
