package jTrolog.engine;

import jTrolog.terms.Int;
import jTrolog.terms.Struct;
import jTrolog.terms.StructAtom;
import jTrolog.errors.PrologException;
import junit.framework.TestCase;

/**
 * @author ivar.orstavik@hist.no
 */
public class TutorialTestCase extends TestCase {

    public void testTutorial() throws Throwable {

        Prolog engine = new Prolog();
        Solution info = engine.solve("P is 6 + 4.");
        if (info.getBinding("P").equals(new Int(10)))
            System.out.println("The value of P is an jTrolog.terms.Int object with the value 10");

        info = engine.solve("P = 'hello world'.");
        if (info.getBinding("P").equals(new StructAtom("hello world")))
            System.out.println("The value of P is an jTrolog.terms.StructAtom object with the value 'hello world'");

        engine.addTheory("a(X) :- b(X).  b(Y) :- c(Y).  c(1).");
        info = engine.solve("a(What).");
        if (info.getSolution().equals(new Struct("a", new Int(1))))
            System.out.println("We have added a rule and got a compund Struct object in return");

        try {
            info = engine.solve("go_figure.");
        } catch (PrologException e) {
            System.out.println("no go_figure rule, an Exception thrown ");
        }
    }

}
